<style>
    img {
        margin: 0px !important;
    }
</style>

# Extensions obligatoires

## ESlint

![img](./images/eslint.jpg)

[lien sur le store Microsoft](https://marketplace.visualstudio.com/items?itemName=dbaeumer.vscode-eslint)

Permet d'ajouter des commentaires JSDoc

Lève des erreurs et des warnings sur le code typescript.

Configuration par défaut

### Configuration

Si vous prenez un erreur liée à un problème de droit dans vas/var cette configuration vous permettra de définir ce qui doit être analysé : 
```json
{
  "eslint.workingDirectories": [
      "./client",
      "./conf",
      "./module",
      "./engine",
      "./src/**/module",
      "./src/**/engine",
      "./src/**/engine/**",
      "./vas/engine/**"
  ]
}
```


## phpfmt

![img](./images/phpfmt.jpg)

[lien sur le store Microsoft](https://marketplace.visualstudio.com/items?itemName=kokororin.vscode-phpfmt)

Permet de formatter le code PHP.

```{Tip}
  Lorsque l'on colle plusieurs namespace dans un fichier php, le formatage se déclenche et ne garde qu'un namespace. Un simple `CTRL+Z` permet d'annuler le formatage et de gagner du temps.
```

```{Warning}
  Cette extension nécessite une ancienne version de php pour fonctionner (Voir phpfmt.php_bin dans la configuration).
```

### Configuration

```json
{
    "[php]": {
        "editor.defaultFormatter": "kokororin.vscode-phpfmt",
    },
    "phpfmt.psr1": true,
    "phpfmt.psr2": false,
    "phpfmt.detect_indent": false,
    "phpfmt.indent_with_space": 2,
    "phpfmt.php_bin": "/var/lib/php-7.4.5/bin/php",
    "phpfmt.passes": [
        "ReindentSwitchBlocks",
        "PSR2KeywordsLowerCase",
        "PSR2LnAfterNamespace",
        "PSR2EmptyFunction",
        "PSR2SingleEmptyLineAndStripClosingTag",
        "StripNewlineAfterClassOpen",
        "StripNewlineAfterCurlyOpen",
        "ShortArray",
        "EliminateDuplicatedEmptyLines",
        "ExtraCommaInArray",
        "AutoSemicolon",
        "AlignTypehint"
    ],
    "phpfmt.exclude": [
        "PSR2CurlyOpenNextLine"
    ]
}
```

## GitLens

![img](./images/gitlens.jpg)

[lien sur le store Microsoft](https://marketplace.visualstudio.com/items?itemName=eamodio.gitlens)

C'est un gestionnaire Git complémentaire à GitKraken (dévellopé par Axosoft également). 

Vous aurez un suivie ligne par ligne directement dans vscode de vos modifications.